import * as React from 'react';
declare type OptionalSpread<T = undefined> = T extends undefined ? [] : [T];
declare type Action<TState, TPayload extends never = never> = (setState: React.Dispatch<React.SetStateAction<TState>>, payload: TPayload) => void;
declare type Actions<TState> = {
    [key: string]: Action<TState>;
};
declare type Params<T extends (...args: never[]) => unknown> = T extends (...args: infer P) => any ? P : never;
declare type MappedActions<TState, TActions extends Actions<TState>> = {
    [P in keyof TActions]: (...payload: OptionalSpread<Params<TActions[P]>[1]>) => void;
};
declare type Store<TState, TActions extends Actions<TState>> = TActions extends undefined ? TState : TState & MappedActions<TState, TActions>;
export default function createStateContext<TState, TActions extends Actions<TState> = {}>(initialState: TState, actions?: TActions): [React.Context<Store<TState, TActions>>, React.FC];
export {};
